/* ====================================================================
  * Copyright (c) 2004 4D, SA.  All rights
  * reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  *
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice.
  *
  * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
  * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED.  IN NO EVENT SHALL 4D, SA ITS SUBSIDIARIES OR
  * ITS EMPLOYEES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  * ====================================================================
  */

package com.fourd.jdbc;

import java.io.*;
import java.math.*;
import java.net.*;
import java.sql.*;
import java.util.*;

import j4d.open.*;

class CallableStatementImpl extends PreparedStatementImpl implements CallableStatement
{
	private Hashtable				m_htOutParameters = new Hashtable ( );
	
	private Hashtable				m_htResults = new Hashtable ( );
	
	CallableStatementImpl (
							ConnectionImpl connImpl,
							opConnection opC,
							opProcess opP,
							DatabaseMetaDataImpl dbMD,
							Object objDataAccessLock,
							String strSQL ) throws SQLException
	{
		super (	connImpl,
				opC,
				opP,
				dbMD,
				objDataAccessLock,
				strSQL );
				
		m_strSQL = strSQL;
		try
		{
			m_sqlCommand = SQLParser. parse ( m_strSQL );
		}
		catch ( Exception e )
		{
			e. printStackTrace ( );
			
			throw new SQLException ( e. getMessage ( ) );
		}
	}

	public Array getArray (int i) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public BigDecimal getBigDecimal ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public BigDecimal getBigDecimal (int parameterIndex, int scale) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public Blob getBlob (int i) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public boolean getBoolean ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		Object				obj = getOUTParameter ( nIndex );
		Boolean				bResult = ( Boolean ) SQLTools. convert ( obj, Boolean. class );
		
		return bResult.booleanValue ( );
	}

	public byte getByte ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		Object				obj = getOUTParameter ( nIndex );
		Byte				btResult = ( Byte ) SQLTools. convert ( obj, Byte. class );
		
		return btResult.byteValue ( );
	}

	public byte [ ] getBytes ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		Object				obj = getOUTParameter ( nIndex );
		byte [ ]			szbtResult = ( byte [ ] ) SQLTools. convert ( obj, byte [ ]. class );
		
		return szbtResult;
	}

	public Clob getClob (int i) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public java.sql.Date getDate ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		Object				obj = getOUTParameter ( nIndex );
		java.sql.Date		dtResult = ( java.sql.Date ) SQLTools. convert ( obj, java.sql.Date. class );
		
		return dtResult;
	}

	public java.sql.Date getDate (int parameterIndex, Calendar cal) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public double getDouble ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		Object				obj = getOUTParameter ( nIndex );
		Double				nResult = ( Double ) SQLTools. convert ( obj, Double. class );
		
		return nResult. doubleValue ( );
	}

	public float getFloat ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		Object				obj = getOUTParameter ( nIndex );
		Float				nResult = ( Float ) SQLTools. convert ( obj, Float. class );
		
		return nResult. floatValue ( );
	}

	public int getInt ( int nIndex ) throws SQLException
	{
		validateOpened ( );

		Object				obj = getOUTParameter ( nIndex );
		Integer				nResult = ( Integer ) SQLTools. convert ( obj, Integer. class );
		
		return nResult.intValue ( );
	}

	public long getLong ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		Object				obj = getOUTParameter ( nIndex );
		Long				nResult = ( Long ) SQLTools. convert ( obj, Long. class );
		
		return nResult. longValue ( );
	}

	public Object getObject ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		return getOUTParameter ( nIndex );
	}

	public Object getObject (int i, Map map) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public Ref getRef (int i) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public short getShort ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		Object				obj = getOUTParameter ( nIndex );
		Short				nResult = ( Short ) SQLTools. convert ( obj, Short. class );
		
		return nResult. shortValue ( );
	}

	public String getString ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		Object				obj = getOUTParameter ( nIndex );
		String				strResult = ( String ) SQLTools. convert ( obj, String. class );
		
		return strResult;
	}

	public Time getTime ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		Object				obj = getOUTParameter ( nIndex );
		Time				tmResult = ( Time ) SQLTools. convert ( obj, Time. class );
		
		return tmResult;
	}

	public Time getTime (int parameterIndex, Calendar cal) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public Timestamp getTimestamp ( int nIndex ) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public Timestamp getTimestamp (int parameterIndex, Calendar cal) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return null;
	}

	public void registerOutParameter (int parameterIndex, int sqlType) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
	}

	public void registerOutParameter (int parameterIndex, int sqlType, int scale) throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
	}

	/**
	*/
	public void registerOutParameter (
								int nIndex,
								int nSQLType,
								String strParameterName ) throws SQLException
	{
		validateOpened ( );

		if ( strParameterName == null )
			throw new SQLException (
								"com.fourd.jdbc.CallableStatement::registerOutParameter: " +
								"Parameter name can not be null" );
		
		opVariable			opVar = new opVariable ( );
		opVar. mVariableName = strParameterName;
		opVar. mVarType = SQLTools. mapSQLTypeTo4DType ( nSQLType );

		m_htOutParameters. put ( new Integer ( nIndex ), opVar );
	} // end of public void registerOutParameter ( ...

	public boolean wasNull () throws SQLException
	{
		validateOpened ( );
			
		throwUnimplementedException ( );
		
		return false;
	}

	private void s_e_p_a_r_a_t_o_r__________________________1 ( )
	{
		;
	}
	
	private void throwUnimplementedException ( ) throws SQLException
	{
		throw new SQLException (
							"com.fourd.jdbc.CallableStatementImpl: " +
							"Method is not implemented" );
	}
	
	private void prepareForExecute ( ) throws SQLException
	{
		// The fact that strSQL is not null is verified when this CallableStatementImpl is created.
		m_sqlCommand. validate ( m_dbMD );
		m_htResults. clear ( );
	} // private void prepareForExecute ( ) throws SQLException
	
	// Overridden methods from PreparedStatement will follow
	private void s_e_p_a_r_a_t_o_r__________________________2 ( )
	{
		;
	}
	
	public boolean execute ( ) throws SQLException
	{
		prepareForExecute ( );
		
		if ( m_sqlCommand. getType ( ) != SQLCommand. CMD_TYPE_STORED_PROCEDURE )
			throw new SQLException ( 
								"com.fourd.jdbc.CallableStatementImpl::execute: " +
								"Not a stored procedure call. Use java.sql.Statement instead" );
		
		opServerProcess			opsProcess = new opServerProcess ( );
		opsProcess. mMethodName = m_sqlCommand. getStoredProcedureName ( );
		
		opsProcess. mProcessName = "JDBC - Host Unknown";
		try
		{
			opsProcess. mProcessName = "JDBC - " + InetAddress. getLocalHost ( ). getHostAddress ( );
		}
		catch ( UnknownHostException uhE )
		{ ; }
		catch ( SecurityException sE )
		{ ; }
		
		opsProcess. mStackSize = 64000;
		opsProcess. mUnique = 0;

		opData [ ]			szopdParameters = m_sqlCommand. getParameters ( );
		opVariableArray		opvArray = null;
		if ( szopdParameters. length > 0 )
		{
			opvArray = new opVariableArray ( szopdParameters. length );
			for ( int i = 0; i < szopdParameters. length; i++ )
				opvArray. mVariableArray [ i ]. mData = szopdParameters [ i ];
		}
		
		try
		{
			m_opProcess. ExecuteOnServer ( opsProcess, opvArray ); // also retrieves mProcessID

			opvArray = new opVariableArray ( 1 );
			opvArray. mVariableArray [ 0 ]. mVariableName = "spErrCode";
			opvArray. mVariableArray [ 0 ]. mVarType = opConstants. LONGINTEGER;
			
			int			nErrorCode = -1;
			while ( nErrorCode != 0 ) // Wait until stored procedure posts "done" notification
			{
				m_opProcess. GetProcessVariable ( opsProcess, opvArray );
				nErrorCode = opvArray. mVariableArray [ 0 ]. mData. mLongInteger;
			}
			
			// Read all registered OUT parameters
			int					nOutParametersCount = m_htOutParameters. size ( );
			opVariableArray		opvaResults = new opVariableArray ( nOutParametersCount );
			Enumeration			enumKeys = m_htOutParameters. keys ( );
			opVariable			opvarParameter = null;
			int					nCounter = 0;
			Object				objKey = null;
			while ( enumKeys. hasMoreElements ( ) )
			{
				objKey = enumKeys. nextElement ( );
				opvarParameter = ( opVariable ) m_htOutParameters. get ( objKey );
				opvaResults. mVariableArray [ nCounter ]. mVariableName = opvarParameter. mVariableName;
				opvaResults. mVariableArray [ nCounter ]. mVarType = opvarParameter. mVarType;
				
				m_htResults. put ( objKey, opvaResults. mVariableArray [ nCounter ] );
				
				nCounter++;
			}
			if ( nOutParametersCount > 0 )
				m_opProcess. GetProcessVariable ( opsProcess, opvaResults );
			
			// Let the stored procedure know that I'm done reading OUT parameters (results)
			opvArray. mVariableArray [ 0 ]. mData = new opData ( opConstants. LONGINTEGER, 1 );
			m_opProcess. SetProcessVariable ( opsProcess, opvArray );
		}
		catch ( opException opE )
		{
			System. out. println ( opE. getMessage ( ) );
			opE. printStackTrace ( );
		}
		
		return false;
	} // end of public boolean execute ( ) throws SQLException
	
	private opVariable extractOUTParameter ( int nIndex ) throws SQLException
	{
		opVariable			opVar = ( opVariable ) m_htResults. get ( new Integer ( nIndex ) );
		if ( opVar == null )
			throw new SQLException (
								"com.fourd.jdbc.CallableStatement::extractOUTParameter: " +
								"OUT parameter with index " + nIndex + " was not registered." );
								
		return opVar;
	}
	
	private Object getOUTParameter ( int nIndex ) throws SQLException
	{
		opVariable			opVar = extractOUTParameter ( nIndex );
		opVar. mData. mType = ( short ) opVar. mVarType; // just to make sure
		
		return SQLTools. convertToJavaObject ( opVar. mData );
	}
}