/* ====================================================================
  * Copyright (c) 2004 4D, SA.  All rights
  * reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  *
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice.
  *
  * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
  * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED.  IN NO EVENT SHALL 4D, SA ITS SUBSIDIARIES OR
  * ITS EMPLOYEES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  * ====================================================================
  */

package com.fourd.jdbc;

import java.util.*;
import java.net.*;

import j4d.open.*;

class ConnectionKeeper
{
	private Vector			m_vctrPingers = new Vector ( );
	
	private Object			m_objDataAccessLock = null;
	
	ConnectionKeeper ( Object objDataAccessLock )
	{
		m_objDataAccessLock = objDataAccessLock;
	}
	
	synchronized void add ( opProcess opP )
	{
		Pinger	pngr = new Pinger ( opP );
		m_vctrPingers. addElement ( pngr );
		pngr. setDaemon ( true );
		pngr. start ( );
	}
	
	private class Pinger extends Thread
	{
		private opProcess				m_opProcess = null;
		private volatile boolean			m_bStop = false;
		private long					m_nSleep = 10000;

		Pinger ( opProcess opP )
		{
			m_opProcess = opP;
		}

		public void run ( )
		{
			while ( !m_bStop )
			{
				synchronized ( m_objDataAccessLock )
				{
					try
					{
						m_opProcess. CountTables ( );
					}
					catch ( opException opE )
					{
						return;
					}
				}
				
				try
				{
					Thread. currentThread ( ). sleep ( m_nSleep );
				}
				catch ( InterruptedException iE )
				{
					return;
				}
			} // end of while ( m_bStop )
		} // end of public void run ( )
		
		void stopPinger ( )
		{
			m_bStop = true;
		}
	} // end of private class Pinger ( opProcess opP ) implements Runnable
	
	synchronized void stopAll ( )
	{
		Pinger	pngr = null;
		for ( int i = 0; i < m_vctrPingers. size ( ); i++ )	
		{
			pngr = ( Pinger ) m_vctrPingers. elementAt ( i );
			pngr. stopPinger ( );
			pngr. interrupt ( );
		}
	}
} // end of class ConnectionKeeper