/* ====================================================================
  * Copyright (c) 2004 4D, SA.  All rights
  * reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  *
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice.
  *
  * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
  * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED.  IN NO EVENT SHALL 4D, SA ITS SUBSIDIARIES OR
  * ITS EMPLOYEES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  * ====================================================================
  */

package com.fourd.jdbc;

import java.sql.*;
import java.util.*;

import j4d.open.*;

/**
*	Represents two columns from one join condition. Just a simple container helper class.
*
*	TODO: JoinCondition and BooleanExpression classes should really be sub-classes of a common super-class.
*/
class JoinCondition
{
	private SQLColumnMetaData			m_sqlcMDLeft = null; // a column to the left of the '=' sign
	private SQLColumnMetaData			m_sqlcMDRight = null; // a column to the right of the '=' sign

	JoinCondition ( SQLColumnMetaData sqlcMDLeft, SQLColumnMetaData sqlcMDRight ) throws Exception
	{
		if ( sqlcMDLeft == null )
			throw new Exception ( "com.fourd.jdbc.JoinCondition::JoinCondition: Left column can not be null" );
		if ( sqlcMDRight == null )
			throw new Exception ( "com.fourd.jdbc.JoinCondition::JoinCondition: Right column can not be null" );
			
		m_sqlcMDLeft = sqlcMDLeft;
		m_sqlcMDRight = sqlcMDRight;
	}
	
	SQLColumnMetaData getLeftColumn ( )
	{
		return m_sqlcMDLeft;
	}

	SQLColumnMetaData getRightColumn ( )
	{
		return m_sqlcMDRight;
	}
}