/* ====================================================================
  * Copyright (c) 2004 4D, SA.  All rights
  * reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  *
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice.
  *
  * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
  * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED.  IN NO EVENT SHALL 4D, SA ITS SUBSIDIARIES OR
  * ITS EMPLOYEES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
  * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
  * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  * ====================================================================
  */

package com.fourd.jdbc;

import j4d.open.*;

/**
*	Instances of this class are used in UPDATE and INSERT commands.
*	Each instance represent a new or updated value for a particular column.
*/
class Value
{
	private String			m_strValue = null;
	private String			m_strColumn = null;
	
	/**
	*	If a value is parameterised ( like in UPDATE MyTable SET MyColumn = ? )
	*	then this value's m_param will be set to a proper Parameter instance.
	*/
	private Parameter		m_param = null;
	
	private opData		m_opdValue = null;
	
	String getValue ( )
	{
		return m_strValue;
	}
	
	void setValue ( String strNewValue )
	{
		m_strValue = strNewValue;
	}
	
	String getColumnName ( )
	{
		return m_strColumn;
	}
	
	void setColumnName ( String strColumn )
	{
		m_strColumn = strColumn;
	}
	
	void setParameter ( Parameter param )
	{
		m_param = param;
	}
	
	Parameter getParameter ( )
	{
		return m_param;
	}
	
	boolean isParameter ( )
	{
		return m_param != null;
	}
	
	opData getopValue ( )
	{
		return m_opdValue;
	}
	
	void setopValue ( opData opdNewValue )
	{
		m_opdValue = opdNewValue;
	}
	
}